﻿/// <reference path="/scripts/qUnit/qunit.js"/>
/// <reference path="/scripts/jquery-1.7.1.min.js"/>
/// <reference path="/Scripts/jquery.validate.js"/>
    
/// <reference path="/Scripts/datajs-1.0.2.js"/>

/// <reference path="/TypeSystem/initializeJayData.js/>
/// <reference path="/TypeSystem/utils.js/>
/// <reference path="/TypeSystem/PreHtml5Compatible.js/>
/// <reference path="/TypeSystem/JayLint.js/>
/// <reference path="/TypeSystem/TypeSystem.js/>
/// <reference path="/Types/Expressions/ASTParser.js/>
/// <reference path="/Types/Expressions/ExpressionNode2.js/>
/// <reference path="/Types/Expressions/ArrayLiteralExpression.js/>
/// <reference path="/Types/Expressions/CallExpression.js/>
/// <reference path="/Types/Expressions/CodeParser.js/>
/// <reference path="/Types/Expressions/ConstantExpression.js/>
/// <reference path="/Types/Expressions/FunctionExpression.js/>
/// <reference path="/Types/Expressions/ObjectFieldExpression.js/>
/// <reference path="/Types/Expressions/ObjectLiteralExpression.js/>
/// <reference path="/Types/Expressions/PagingExpression.js/>
/// <reference path="/Types/Expressions/ParameterExpression.js/>
/// <reference path="/Types/Expressions/PropertyExpression.js/>
/// <reference path="/Types/Expressions/SimpleBinaryExpression.js/>
/// <reference path="/Types/Expressions/ThisExpression.js/>
/// <reference path="/Types/Expressions/Visitors/ExpressionVisitor.js/>
/// <reference path="/Types/Expressions/Visitors/ParameterProcessor.js/>
/// <reference path="/Types/Expressions/Visitors/GlobalContextProcessor.js/>
/// <reference path="/Types/Expressions/Visitors/LocalContextProcessor.js/>
/// <reference path="/Types/Expressions/Visitors/LambdaParameterProcessor.js/>
/// <reference path="/Types/Expressions/Visitors/ParameterResolverVisitor.js/>
/// <reference path="/Types/Expressions/Visitors/LogicalSchemaBinderVisitor.js/>
/// <reference path="/Types/Expressions/Visitors/ExpTreeVisitor.js/>
/// <reference path="/Types/Expressions/Visitors/SetExecutableVisitor.js/>
/// <reference path="/Types/Expressions/Visitors/ExecutorVisitor.js/>
/// <reference path="/Types/Expressions/ExpressionBuilder.js/>
/// <reference path="/Types/Expressions/EntityExpressions/AssociationInfoExpression.js/>
/// <reference path="/Types/Expressions/EntityExpressions/CodeExpression.js/>
/// <reference path="/Types/Expressions/EntityExpressions/CodeToEntityConverter.js/>
/// <reference path="/Types/Expressions/EntityExpressions/ComplexTypeExpression.js/>
/// <reference path="/Types/Expressions/EntityExpressions/EntityContextExpression.js/>
/// <reference path="/Types/Expressions/EntityExpressions/EntityExpression.js/>
/// <reference path="/Types/Expressions/EntityExpressions/EntityExpressionVisitor.js/>
/// <reference path="/Types/Expressions/EntityExpressions/EntityFieldExpression.js/>
/// <reference path="/Types/Expressions/EntityExpressions/EntityFieldOperationExpression.js/>
/// <reference path="/Types/Expressions/EntityExpressions/EntitySetExpression.js/>
/// <reference path="/Types/Expressions/EntityExpressions/FilterExpression.js/>
/// <reference path="/Types/Expressions/EntityExpressions/IncludeExpression.js/>
/// <reference path="/Types/Expressions/EntityExpressions/MemberInfoExpression.js/>
/// <reference path="/Types/Expressions/EntityExpressions/OrderExpression.js/>
/// <reference path="/Types/Expressions/EntityExpressions/ParametricQueryExpression.js/>
/// <reference path="/Types/Expressions/EntityExpressions/ProjectionExpression.js/>
/// <reference path="/Types/Expressions/EntityExpressions/QueryExpressionCreator.js/>
/// <reference path="/Types/Expressions/EntityExpressions/QueryParameterExpression.js/>
/// <reference path="/Types/Expressions/EntityExpressions/RepresentationExpression.js/>
/// <reference path="/Types/Validation/EntityValidationBase.js/>
/// <reference path="/Types/Validation/EntityValidation.js/>
/// <reference path="/Types/Notifications/ChangeDistributorBase.js/>
/// <reference path="/Types/Notifications/ChangeCollectorBase.js/>
/// <reference path="/Types/Notifications/ChangeDistributor.js/>
/// <reference path="/Types/Notifications/ChangeCollector.js/>
/// <reference path="/Types/Promise.js/>
/// <reference path="/Types/Entity.js/>
/// <reference path="/Types/EntityContext.js/>
/// <reference path="/Types/QueryProvider.js/>
/// <reference path="/Types/RowConverter.js/>
/// <reference path="/Types/Query.js/>
/// <reference path="/Types/Queryable.js/>
/// <reference path="/Types/EntitySet.js/>
/// <reference path="/Types/AuthEntityContext.js/>
/// <reference path="/Types/EntityState.js/>
/// <reference path="/Types/EntityStateManager.js/>
/// <reference path="/Types/Exception.js/>
/// <reference path="/Types/StorageProviderBase.js/>
/// <reference path="/Types/DbClient/DbCommand.js/>
/// <reference path="/Types/DbClient/DbConnection.js/>
/// <reference path="/Types/DbClient/OpenDatabaseClient/OpenDbCommand.js/>
/// <reference path="/Types/DbClient/OpenDatabaseClient/OpenDbConnection.js/>
/// <reference path="/Types/DbClient/JayStorageClient/JayStorageCommand.js/>
/// <reference path="/Types/DbClient/JayStorageClient/JayStorageConnection.js/>
/// <reference path="/Types/DbClient/SqLiteNjClient/SqLiteNjCommand.js/>
/// <reference path="/Types/DbClient/SqLiteNjClient/SqLiteNjConnection.js/>
/// <reference path="/Types/StorageProviders/SqLite/SqLiteStorageProvider.js/>
/// <reference path="/Types/StorageProviders/modelBinderConfigCompiler.js/>
/// <reference path="/Types/StorageProviders/SqLite/SqLiteCompiler.js/>
/// <reference path="/Types/StorageProviders/SqLite/SqlPagingCompiler.js/>
/// <reference path="/Types/StorageProviders/SqLite/SqlOrderCompiler.js/>
/// <reference path="/Types/StorageProviders/SqLite/SqlProjectionCompiler.js/>
/// <reference path="/Types/StorageProviders/SqLite/ExpressionMonitor.js/>
/// <reference path="/Types/StorageProviders/SqLite/SqlFilterCompiler.js/>
/// <reference path="/Types/StorageProviders/oData/oDataProvider.js/>
/// <reference path="/Types/StorageProviders/oData/oDataCompiler.js/>
/// <reference path="/Types/StorageProviders/oData/oDataWhereCompiler.js/>
/// <reference path="/Types/StorageProviders/oData/oDataOrderCompiler.js/>
/// <reference path="/Types/StorageProviders/oData/oDataPagingCompiler.js/>
/// <reference path="/Types/StorageProviders/oData/oDataProjectionCompiler.js/>
/// <reference path="/Types/StorageProviders/IndexedDB/IndexedDBStorageProvider.js/>
/// <reference path="/Types/Authentication/AuthenticationBase.js/>
/// <reference path="/Types/Authentication/Anonymous.js/>
/// <reference path="/Types/Authentication/FacebookAuth.js/>
/// <reference path="/Types/StorageProviders/Facebook/FacebookProvider.js/>
/// <reference path="/Types/StorageProviders/Facebook/FacebookCompiler.js/>
/// <reference path="/Types/StorageProviders/Facebook/EntitySets/FQL/user.js/>
/// <reference path="/Types/StorageProviders/Facebook/EntitySets/FQL/friend.js/>
/// <reference path="/Types/StorageProviders/Facebook/EntitySets/FQL/page.js/>
/// <reference path="/Types/StorageProviders/Facebook/EntitySets/FQLContext.js/>
/// <reference path="/Types/StorageProviders/YQL/YQLProvider.js/>
/// <reference path="/Types/StorageProviders/YQL/YQLCompiler.js/>
/// <reference path="/Types/StorageProviders/YQL/EntitySets/geo.js/>
/// <reference path="/Types/StorageProviders/YQL/EntitySets/YQLContext.js/>
/// <reference path="/Modules/deferred.js/>
/// <reference path="/Modules/formBinder.js/>
/// <reference path="/Modules/template.js/>
/// <reference path="/Modules/validate.js/>
/// <reference path="/NewsReaderContext.js"/>